/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.Objects;

/**
 * HarvestSource
 */

public class HarvestSource {
  @JsonProperty("active")
  private Boolean active = false;

  @JsonProperty("autoarchive")
  private Boolean autoarchive = true;

  /**
   * The source backend
   */
  public enum BackendEnum {
    DCAT("dcat"),
    
    ODS("ods"),
    
    MAAF("maaf"),
    
    CKAN("ckan"),
    
    DKAN("dkan");

    private String value;

    BackendEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static BackendEnum fromValue(String text) {
      for (BackendEnum b : BackendEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("backend")
  private BackendEnum backend = null;

  @JsonProperty("config")
  private Object config = null;

  @JsonProperty("created_at")
  private LocalDateTime createdAt = null;

  @JsonProperty("deleted")
  private LocalDateTime deleted = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("last_job")
  private Object lastJob = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("organization")
  private Object organization = null;

  @JsonProperty("owner")
  private Object owner = null;

  @JsonProperty("schedule")
  private String schedule = null;

  @JsonProperty("url")
  private String url = null;

  @JsonProperty("validation")
  private Object validation = null;

  public HarvestSource active(Boolean active) {
    this.active = active;
    return this;
  }

   /**
   * Is this source active
   * @return active
  **/
  @ApiModelProperty(required = true, value = "Is this source active")
  public Boolean isActive() {
    return active;
  }

  public void setActive(Boolean active) {
    this.active = active;
  }

  public HarvestSource autoarchive(Boolean autoarchive) {
    this.autoarchive = autoarchive;
    return this;
  }

   /**
   * If enabled, datasets not present on the remote source will be automatically archived
   * @return autoarchive
  **/
  @ApiModelProperty(required = true, value = "If enabled, datasets not present on the remote source will be automatically archived")
  public Boolean isAutoarchive() {
    return autoarchive;
  }

  public void setAutoarchive(Boolean autoarchive) {
    this.autoarchive = autoarchive;
  }

  public HarvestSource backend(BackendEnum backend) {
    this.backend = backend;
    return this;
  }

   /**
   * The source backend
   * @return backend
  **/
  @ApiModelProperty(example = "dcat", required = true, value = "The source backend")
  public BackendEnum getBackend() {
    return backend;
  }

  public void setBackend(BackendEnum backend) {
    this.backend = backend;
  }

  public HarvestSource config(Object config) {
    this.config = config;
    return this;
  }

   /**
   * The configuration as key-value pairs
   * @return config
  **/
  @ApiModelProperty(value = "The configuration as key-value pairs")
  public Object getConfig() {
    return config;
  }

  public void setConfig(Object config) {
    this.config = config;
  }

  public HarvestSource createdAt(LocalDateTime createdAt) {
    this.createdAt = createdAt;
    return this;
  }

   /**
   * The source creation date
   * @return createdAt
  **/
  @ApiModelProperty(required = true, value = "The source creation date")
  public LocalDateTime getCreatedAt() {
    return createdAt;
  }

  public void setCreatedAt(LocalDateTime createdAt) {
    this.createdAt = createdAt;
  }

  public HarvestSource deleted(LocalDateTime deleted) {
    this.deleted = deleted;
    return this;
  }

   /**
   * The source deletion date
   * @return deleted
  **/
  @ApiModelProperty(value = "The source deletion date")
  public LocalDateTime getDeleted() {
    return deleted;
  }

  public void setDeleted(LocalDateTime deleted) {
    this.deleted = deleted;
  }

  public HarvestSource description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The source description
   * @return description
  **/
  @ApiModelProperty(value = "The source description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * The source unique identifier
   * @return id
  **/
  @ApiModelProperty(value = "The source unique identifier")
  public String getId() {
    return id;
  }

  public HarvestSource lastJob(Object lastJob) {
    this.lastJob = lastJob;
    return this;
  }

   /**
   * The last job for this source
   * @return lastJob
  **/
  @ApiModelProperty(value = "The last job for this source")
  public Object getLastJob() {
    return lastJob;
  }

  public void setLastJob(Object lastJob) {
    this.lastJob = lastJob;
  }

  public HarvestSource name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The source display name
   * @return name
  **/
  @ApiModelProperty(required = true, value = "The source display name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public HarvestSource organization(Object organization) {
    this.organization = organization;
    return this;
  }

   /**
   * The producer organization
   * @return organization
  **/
  @ApiModelProperty(value = "The producer organization")
  public Object getOrganization() {
    return organization;
  }

  public void setOrganization(Object organization) {
    this.organization = organization;
  }

  public HarvestSource owner(Object owner) {
    this.owner = owner;
    return this;
  }

   /**
   * The owner information
   * @return owner
  **/
  @ApiModelProperty(value = "The owner information")
  public Object getOwner() {
    return owner;
  }

  public void setOwner(Object owner) {
    this.owner = owner;
  }

   /**
   * The source schedule (interval or cron expression)
   * @return schedule
  **/
  @ApiModelProperty(value = "The source schedule (interval or cron expression)")
  public String getSchedule() {
    return schedule;
  }

  public HarvestSource url(String url) {
    this.url = url;
    return this;
  }

   /**
   * The source base URL
   * @return url
  **/
  @ApiModelProperty(required = true, value = "The source base URL")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public HarvestSource validation(Object validation) {
    this.validation = validation;
    return this;
  }

   /**
   * Has the source been validated
   * @return validation
  **/
  @ApiModelProperty(value = "Has the source been validated")
  public Object getValidation() {
    return validation;
  }

  public void setValidation(Object validation) {
    this.validation = validation;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HarvestSource harvestSource = (HarvestSource) o;
    return Objects.equals(this.active, harvestSource.active) &&
        Objects.equals(this.autoarchive, harvestSource.autoarchive) &&
        Objects.equals(this.backend, harvestSource.backend) &&
        Objects.equals(this.config, harvestSource.config) &&
        Objects.equals(this.createdAt, harvestSource.createdAt) &&
        Objects.equals(this.deleted, harvestSource.deleted) &&
        Objects.equals(this.description, harvestSource.description) &&
        Objects.equals(this.id, harvestSource.id) &&
        Objects.equals(this.lastJob, harvestSource.lastJob) &&
        Objects.equals(this.name, harvestSource.name) &&
        Objects.equals(this.organization, harvestSource.organization) &&
        Objects.equals(this.owner, harvestSource.owner) &&
        Objects.equals(this.schedule, harvestSource.schedule) &&
        Objects.equals(this.url, harvestSource.url) &&
        Objects.equals(this.validation, harvestSource.validation);
  }

  @Override
  public int hashCode() {
    return Objects.hash(active, autoarchive, backend, config, createdAt, deleted, description, id, lastJob, name, organization, owner, schedule, url, validation);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HarvestSource {\n");

    sb.append("    active: ").append(toIndentedString(active)).append("\n");
    sb.append("    autoarchive: ").append(toIndentedString(autoarchive)).append("\n");
    sb.append("    backend: ").append(toIndentedString(backend)).append("\n");
    sb.append("    config: ").append(toIndentedString(config)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    deleted: ").append(toIndentedString(deleted)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lastJob: ").append(toIndentedString(lastJob)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    organization: ").append(toIndentedString(organization)).append("\n");
    sb.append("    owner: ").append(toIndentedString(owner)).append("\n");
    sb.append("    schedule: ").append(toIndentedString(schedule)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    validation: ").append(toIndentedString(validation)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

